
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Red
#property  indicator_color2  Blue
#property  indicator_color3  MediumSeaGreen
#property  indicator_color4  Goldenrod


extern int FastEMA=25;
extern int SlowEMA=170;


extern int FastEMA2=75;
extern int SlowEMA2=510;

extern int FastEMA3=150;
extern int SlowEMA3=1020;

extern int FastEMA4=5;
extern int SlowEMA4=34;

double MacdBuffer[],MacdBuffer2[],MacdBuffer3[],MacdBuffer4[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,MacdBuffer2);
   SetIndexBuffer(2,MacdBuffer3);
   SetIndexBuffer(3,MacdBuffer4);

   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
       {
         MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
         MacdBuffer2[i]=iMA(NULL,0,FastEMA2,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA2,0,MODE_EMA,PRICE_CLOSE,i);
         MacdBuffer3[i]=iMA(NULL,0,FastEMA3,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA3,0,MODE_EMA,PRICE_CLOSE,i);
         MacdBuffer4[i]=iMA(NULL,0,FastEMA4,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA4,0,MODE_EMA,PRICE_CLOSE,i);
       } 

      return(0);
  }
//+------------------------------------------------------------------+